=== debian/rules ===
#!/usr/bin/make -f


VERSION  := $(shell dpkg-parsechangelog|grep ^Version|awk '{print $$2}')
UVERSION := $(shell echo $(VERSION)|sed 's/-[[:digit:]]\+$$//')

DEB_CMAKE_EXTRA_FLAGS := \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_INSTALL_SYSCONFDIR=/etc \
	-DCMAKE_INSTALL_LOCALSTATEDIR=/var \
	-DENABLE_BUNDLED_LIBYAML=OFF \
	-DENABLE_DIST=ON \
	-DWITH_SYSVINIT=ON \
	-DWITH_SYSTEMD=OFF

DEB_DH_INSTALLINIT_ARGS := --name=tarantool

# Needed for proper backtraces in fiber.info()
DEB_DH_STRIP_ARGS	        := -X/usr/bin/tarantool
export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector,-pie
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

debian/%.manpages: debian/%.manpages.in
	sed 's/@DEB_BUILDDIR@/$(DEB_BUILDDIR)/g' $< > $@

build-indep: debian/tarantool.manpages debian/tarantool-common.manpages

tarball: clean
	git describe --long --always > VERSION
	tar --exclude=.git --exclude=debian 		\
		--exclude=doc/www					\
		--exclude=doc/sphinx				\
		--exclude=src/lib/small/debian		\
		--exclude=src/lib/msgpuck/debian    \
		--exclude=test-run/lib/tarantool-python/debian \
		--exclude=third_party/sophia/debian \
		--exclude=third_party/luafun/debian \
		--exclude=FreeBSD \
		--transform='s,^\.,tarantool_$(UVERSION),S' \
		-czf ../tarantool_$(UVERSION).orig.tar.gz .

clean::
	find -type f -name \*.pyc -delete
	find -type d -name CMakeFiles -exec rm -fr '{}' +
	rm -f CMakeCache.txt
	rm -f CPackConfig.cmake
	rm -f CPackSourceConfig.cmake
	rm -f src/trivia/config.h

install/tarantool::
