## tarantool 1.7.2.135.gcdf16ed

=== debian/changelog ===
tarantool (1.7.2.135.gcdf16ed-1) unstable; urgency=medium

  * Fix unowned symlink on example.lua after purge. Closes: #842073.
  * Add conflict on tarantool-lts-dev. Closes: #842086.
  * Bump debhelper compact version as suggested by lintian.

 -- Roman Tsisyk <roman@tarantool.org>  Wed, 26 Oct 2016 14:12:52 +0300

tarantool (1.7.2.29.g2ad1af9-1) unstable; urgency=medium

  * Drop conflicts with tarantool-lts and tarantool-common-lts.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 11 Oct 2016 16:14:56 +0300

tarantool (1.7.2.21.g7131b0c-1) unstable; urgency=medium

  * Fix "tarantool.1: No such file or directory" on buildd

 -- Roman Tsisyk <roman@tarantool.org>  Thu, 06 Oct 2016 18:06:35 +0300

tarantool (1.7.2.19.g4c8bf56-1) unstable; urgency=medium

  * Vinyl - a new write-optimized storage engine, allowing the amount of
    data stored to exceed the amount of available RAM 10-100x times.
  * A new binary protocol command for CALL, which no more restricts a function
    to returning an array of tuples and allows returning an arbitrary
    MsgPack/JSON result, including scalars, nil and void (nothing).
  * New indexable data types: unsigned, integer, number and scalar.
  * Automatic replication cluster bootstrap; it's now much easier to configure
    a new replication cluster.
  * memtx snapshots and xlog files are now compressed on the fly using the
    fast ZStandard compression algorithm. Compression options are configured
    automatically to get an optimal trade-off between CPU utilization and disk
    throughput.
  * fiber.cond() - a new synchronization mechanism for fibers.
  * Tab-based autocompletion in the interactive console.
  * A new implementation of net.box improving performance and solving
    problems with the garbage collection of dead connections.
  * Native systemd support alongside sysvinit.
  * A ready-to-use 'example.lua' instance enable by default.
  * Dozens of bugfixes:
    https://github.com/tarantool/tarantool/issues?q=milestone%3A1.7.2+is%3Aclosed

 -- Roman Tsisyk <roman@tarantool.org>  Thu, 06 Oct 2016 15:21:41 +0300

tarantool (1.6.9.6.g660e882-1) unstable; urgency=medium

  * Add dependency on network configuration files used by `socket` module

 -- Roman Tsisyk <roman@tarantool.org>  Wed, 28 Sep 2016 14:23:42 +0300

tarantool (1.6.9.1.g3a3f705-1) unstable; urgency=medium

  * Tab-based autocompletion in the interactive console
  * LUA_PATH and LUA_CPATH environment variables taken into account
  * A new box.cfg { read_only = true } option
  * Upgrade script for 1.6.4 -> 1.6.8 -> 1.6.9
  * Bugs fixed:
  https://github.com/tarantool/tarantool/issues?q=milestone%3A1.6.9+is%3Aclosed

 -- Roman Tsisyk <roman@tarantool.org>  Mon, 26 Sep 2016 16:21:39 +0300

tarantool (1.6.8.762.g15ed10e-1) unstable; urgency=medium

  * Add support for OpenSSL 1.1 (FTBFS). Closes: #835798.

 -- Roman Tsisyk <roman@tarantool.org>  Thu, 01 Sep 2016 09:34:24 +0300
